#include <iostream>
#include <stdlib.h>
using namespace std;

//     ============>  
//    -|-    |     |
//   --|--   |     |
//  ---|---  |     |
//     1     2     3 

int nopr = 0;                                // число операций переноса 
bool debug = false;                          // признак диагностического вывода
const short inlin = 5;

void put( int from, int to ) {               // индикация операции переноса
   ++nopr;
   if( !debug ) return;
   cout << from << " => " << to 
        << ( 0 == ( nopr % inlin ) ? "\n" : ",   " ); 
}

inline int temp( int from, int to ) {       // выбрать промежуточнуя позиция
   return from ^ to;                        // (1,2)->3, (2,3)->1, ...
}

void move( int from, int to, int n ) {       // перенос с #from на #to n колец
   if( 1 == n ) put( from, to );             // просто перенос 1-го кольца
   else { 
      move( from, temp( from, to ), n - 1 ); // перенести n-1 верхних
      put( from, to );                       // перенести самое нижнее
      move( temp( from, to ), to, n - 1 );   // поставить n-1 верхних
   }
}

int main( int argc, char **argv, char **envp ) {
   if( argc != 2 )
      cout << "usage: " << argv[ 0 ] << " [-]<number>" << endl, exit( 1 );
   int size = atoi( argv[ 1 ] );             // число переносимых фишек
   if( size < 0 ) size = -size, debug = true;
   if( debug ) cout << "размер пирамиды: " << size << endl; 
   move( 1, 3, size );                       // вот и всё решение!
   if( debug && ( nopr % inlin ) != 0 )
      cout << endl;                          // только для красоты
   cout << "общее число перемещений " << nopr << endl; 
   return 0;
}
